/*
 * File: Smiley.h
 * --------------
 * "Derived" class: Smiley
 * The shape interface must be available to it.
 */

#ifndef SMILEY_H
#define SMILEY_H

typedef struct SmileyCDT *Smiley;

// The access to the interface (base class)
Shape SmileyShape(Smiley smiley);
// Derived class constructor when the base "shape" is already constructed
Smiley SmileyCreate(Shape shape, float radius);
// Smiley methods
int SmileyCounter(void); // class method
float SmileyGetRadius(Smiley smiley);
void SmileySetRadius(Smiley smiley, float new_radius);

#endif // SMILEY_H

